/**
 * Instant YAML - a very simple and fast YAML parser
 *
 * @copyright 2019 cepharum GmbH, Berlin, Germany - https://cepharum.de
 * @license MIT
 */
"use strict";!function(){const e=0,a=1,t=2,s=3,r=4,c=5,n=6,l=7,i=8,u=9,o=10,d=11,b=12,f={character:"invalid character",indentation:"invalid indentation",linebreak:"invalid linebreak",comment:"invalid comment",depth:"invalid depth of hierarchy",exists:"replacing existing property of same object",collection:"invalid mix of collections",scalar:"collection expected, but got scalar",folded:"invalid folded value",quote:"missing closing quote",eof:"unexpected end of file"},h={},k=[];function m(e,a,t){throw new Error(e+" in line "+a+", column "+t)}function p(e,a){switch(a){case"n":return"\n";case"t":return"\t";case"f":return"\f";case"v":return"\v";default:return a}}module.exports.YAML={parse:function(v,y){const g=y||[];if("object"==typeof v&&v)return v;if("string"!=typeof v)throw new TypeError("invalid or missing code to be parsed");const w=v.length,A=[{depth:0,selector:null,ref:{}}];let I=e,N=null,x=1,P=1,$=0,q=0,j=0;for(let y=0;y<=w;y++,P++){const S=y<w?v[y]:"\n";switch(I){case e:switch(S){case" ":case"\t":break;case"\r":I=a;break;case"\n":$=y+1;break;case"#":if(!N||!N.folded){I=o;break}default:if(j=y-(q=$),N&&N.folded){if(j>N.depth){null==N.value&&(N.foldedIndentation=j-N.depth),$+=N.depth,I=l;break}this.consume(N,A,g),N=null}switch(N={depth:j,line:x,column:P},$=y,S){case"'":case'"':I=s;break;case"-":I=b,$=y;break;default:I=t,y--,P--}}break;case b:if(!/\s/.test(S)&&(N.isProperty||N.isArrayItem&&/[\d.]/.test(S)))I=n;else{if(N.isArrayItem||N.isProperty){const e=v.substring($,y);N.value=N.isArrayItem?k:h,this.consume(N,A,g),N={depth:N.depth+1+e.match(/^\s*/)[0].length,isArrayItem:!0,line:x,column:P}}else N.isArrayItem=!0;switch(S){case"\r":N.value=h,this.consume(N,A,g),I=a;break;case"\n":N.value=k,this.consume(N,A,g),I=e,$=y+1;break;case" ":case"\t":default:I=n,$=y}}break;case a:"\n"!==S&&m(f.linebreak,x,P),I=e,$=y+1;break;case t:switch(S){case":":N.isProperty=!0,N.propertyName=v.substring($,y).trim(),I=n,$=y+1;break;case" ":case"\t":N.isProperty=!0,N.propertyName=v.substring($,y).trim(),I=c;break;case"\r":case"\n":m(f.linebreak,x,P);break;case"#":m(f.comment,x,P);break;default:/[:]/.test(S)&&m(f.character,x,P)}break;case s:switch(S){case"\\":I=r;break;case"\r":case"\n":m(f.linebreak,x,P);break;case v[$]:N.isProperty=!0,N.propertyName=v.substring($+1,y).replace(/\\(.)/g,p),I=c}break;case r:switch(S){case"\r":case"\n":m(f.linebreak,x,P);break;default:I=s}break;case c:switch(S){case":":I=n,$=y+1;break;case" ":case"\t":break;case"\r":case"\n":m(f.linebreak,x,P);break;case"#":m(f.comment,x,P);break;default:m(f.character,x,P)}break;case n:switch(S){case"#":N.value=v.substring($,y).trim(),I=o;break;case"'":case'"':/\S/.test(v.substring($,y))||(I=i,$=N.quotedValue=y);break;case"\r":N.value=v.substring($,y).trim(),""===N.value&&(N.value=h),I=a;break;case"\n":N.value=v.substring($,y).trim(),""===N.value&&(N.value=h),I=e,$=y+1;break;case":":if(N.isArrayItem||N.isProperty){const e=v.substring($,y),a=e.trim();/^[a-zA-Z0-9_]+$/.test(a)&&(N.value=h,this.consume(N,A,g),N={depth:N.depth+1+e.match(/^\s*/)[0].length,isProperty:!0,propertyName:a,line:x,column:P},$=y+1)}break;case"-":if(N.isArrayItem||N.isProperty){v.substring($,y).trim().length||(I=b)}}switch(N.value){case">":case">-":case">+":case"|":case"|-":case"|+":N.folded=N.value,N.value=null;break;case null:case void 0:break;case"":N.value=h;default:this.consume(N,A,g),N=null}break;case i:switch(S){case"\\":I=u;break;case"\r":case"\n":m(f.linebreak,x,P);break;case v[$]:N.value=v.substring($+1,y).replace(/\\(.)/g,p),I=d,$=y+1}break;case u:switch(S){case"\r":case"\n":m(f.linebreak,x,P);break;default:I=i}break;case l:{let t=!1;switch(S){case"\r":t=!0;case"\n":{const s=v.substr($,N.foldedIndentation);let r=v.substring($+N.foldedIndentation,y);const c=/\S/.exec(s);if(c){const e=N.foldedIndentation-c.index;let a="";for(let t=0;t<e;t++)a+=" ";N.value=N.value.replace(/(^|\n(?=\s*\S))/g,"$1"+a),N.foldedIndentation=c.index,r=s.substr(c.index)+r}N.value=(null==N.value?"":N.value)+r,t?I=a:(I=e,$=y+1);break}}break}case o:switch(S){case"\r":I=a;break;case"\n":I=e,$=y+1}break;case d:switch(S){case" ":case"\t":break;case"\r":this.consume(N,A,g),N=null,I=a;break;case"\n":this.consume(N,A,g),N=null,I=e,$=y+1;break;case"#":this.consume(N,A,g),N=null,I=o;break;case":":if(N.isArrayItem&&"string"==typeof N.value){const e=N.value;if(/^[a-zA-Z0-9_]+$/.test(e)){N.value=h,this.consume(N,A,g),N={depth:N.startQuote+1+N.value.match(/^\s*/)[0].length,isProperty:!0,propertyName:e,line:x,column:P},I=n,$=y+1;break}}m(f.character,x,P);break;default:m(f.character,x,P)}}"\n"===S&&y<w&&(N&&N.folded&&null!=N.value&&(N.value+="\n"),x++,P=0)}switch(I){case n:switch(N.value=v.substring($).trim(),N.value){case"|":case">":m(f.folder,x,P);break;case"":N.value=h;default:this.consume(N,A,g),N=null}break;case d:this.consume(N,A,g);break;case e:N&&N.folded&&this.consume(N,A,g);break;case o:break;case s:case r:case i:case u:m(f.quote,x,P);break;default:m(f.eof,x,P)}return A[A.length-1].ref},consume:function(e,a,t){const s=e.depth;for(;;){const t=a[0];if(!t)return void m(f.depth,e.line,e.column);const r=t.depth;if(isNaN(r)&&(a[1]||{}).depth<s){t.depth=s;break}if(r===s)break;r<s&&m(f.indentation,e.line,e.column),a.shift()}switch(e.value){case k:case h:{let s=a[0].ref,r=Array.isArray(s);e.isArrayItem&&!r&&0===Object.keys(s).length&&(s=a[0].ref=[],r=!0,a.length>1&&(a[1].ref[a[0].selector]=s));const c=r?s.length:e.propertyName,n=e.value===k?[]:{};return a.unshift({depth:NaN,selector:c,ref:n}),r?s.push(n):s[e.propertyName]=n,void t.push(e)}}let r=a[0].ref;if(e.isArrayItem^Array.isArray(r)){if(Object.keys(r).length>0)return void m(f.collection,e.line,e.column);const t=a[0].selector;r=e.isArrayItem?a[0].ref=[]:a[0].ref={},null!=t&&a.length>1&&(a[1].ref[t]=r)}switch(e.value){case h:case k:m(f.indentation,e.line,e.column);break;default:if(e.folded){const a=/^([|>])([+-])?$/.exec(e.folded);e.value=e.value.replace(/(\n\s*$)|(?:\n([^ \t]))/g,function(e,t,s){if(t)switch(a[2]){case"+":return t;case"-":return"";default:return"\n"}return(">"===a[1]?"\n"===s?"":" ":"\n")+s})}else if(!e.quotedValue){const a=e.value.trim();"null"===a?e.value=null:/^(?:y(?:es)?|true|on)$/i.test(a)?e.value=!0:/^(?:no?|false|off)$/i.test(a)?e.value=!1:a.replace(/^[+-]/,"").length>0&&/^(?:[+-])?(?:\d+)?(?:\.\d+)?$/i.test(a)?e.value=parseFloat(a):e.value=a}}e.isArrayItem?r.push(e.value):e.isProperty?r[e.propertyName]=e.value:m(f.scalar,e.line,e.column),t.push(e)}}}();